package smash.appointment.parse;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.poi.ss.usermodel.Row;

public class LihControlMappingParser extends SubjectParser {

	@Override
	protected String parseScreeningNumber(Row row) {
		String number = getString(row.getCell(0));
		if (number.trim().isEmpty()) {
			return "";
		} else {
			if (number.length() == 1) {
				number = "00" + number;
			} else if (number.length() == 2) {
				number = "0" + number;
			}
			return "L-" + number;
		}
	}

	@Override
	protected String parseName(Row row) {
		return getString(row.getCell(8));
	}

	@Override
	protected String parseSurname(Row row) {
		return getString(row.getCell(9));
	}

	@Override
	protected String parseNdNumber(Row row) {
		String number = getString(row.getCell(7));
		
		if (number.equalsIgnoreCase("PK") ||number.equalsIgnoreCase("CHEM") || number.equalsIgnoreCase("Flying Team")) {
			number = "";
		}
		return number;
	}

	@Override
	protected String getSheetName() {
		return "Sheet1";
	}

	@Override
	protected int getInitRow() {
		return 1;
	}

	@Override
	protected String parseBirthDate(Row row) {
		return "";
	}

	@Override
	protected String parsemPowerId(Row row) {
		return "";
	}

	@Override
	protected String parseAddDate(Row row) {
		return getDate(row.getCell(1), Calendar.getInstance());
	}

	@Override
	protected String parseReferal(Row row) {
		return "";
	}

	@Override
	protected String parseDiagnosisYear(Row row) {
		return "";
	}

	@Override
	protected String parseMail(Row row) {
		return "";
	}

	@Override
	protected String parsePhone3(Row row) {
		return "";
	}

	@Override
	protected String parsePhone2(Row row) {
		return "";
	}

	@Override
	protected String parsePhone1(Row row) {
		return getString(row.getCell(10));
	}

	@Override
	protected String parseCity(Row row) {
		return "";

	}

	@Override
	protected String parseCountry(Row row) {
		return "";
	}

	@Override
	protected String parseZipCode(Row row) {
		return "";
	}

	@Override
	protected String parseAddress(Row row) {
		return "";
	}

	@Override
	protected String parseRemarks(Row row) {
		return "";
	}

	@Override
	protected String parseDiagnosis(Row row) {
		return "";
	}

	@Override
	protected SubjectType parseType(Row row) {
		return SubjectType.CONTROL;
	}

	@Override
	protected List<String> parseLanguages(Row row) {
		return new ArrayList<>();
	}

	@Override
	protected String parseToBeSeenAt(Row row) {
		return "L";
	}

	@Override
	protected boolean parseDead(Row row) {
		return false;
	}

	@Override
	protected boolean parseResigned(Row row) {
		return false;
	}

	@Override
	protected boolean parsePostponed(Row row) {
		return false;
	}

}
