package smash.appointment.parse;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.log4j.Logger;

public class Visit {
	static Subject UNKNOWN;
	static {
		UNKNOWN = new Subject("NOBODY", "", "", "---");
		UNKNOWN.setType(SubjectType.CONTROL);
		UNKNOWN.setAddDate("1900-01-01");
		UNKNOWN.setAddress("");
		UNKNOWN.setZipCode("");
		UNKNOWN.setCity("");
		UNKNOWN.setCountry("");
		UNKNOWN.setmPowerId("");
		UNKNOWN.setReferal("");
		UNKNOWN.setRemarks("");
		UNKNOWN.setDiagnosis("");
		UNKNOWN.setToBeSeenAt("P");
	}
	Logger												 logger				= Logger.getLogger(Visit.class);

	private Subject								 subject;
	private List<AppointmentEntry> appointments	= new ArrayList<>();

	private String								 startDate;
	private boolean								 finished			= false;

	public Visit(Subject subject) {
		if (subject == null) {
			subject = UNKNOWN;
		}
		this.subject = subject;
	}

	public void addAppointment(AppointmentEntry entry) {
		appointments.add(entry);
	}

	/**
	 * @return the appointments
	 * @see #appointments
	 */
	public List<AppointmentEntry> getAppointments() {
		return appointments;
	}

	/**
	 * @param appointments
	 *          the appointments to set
	 * @see #appointments
	 */
	public void setAppointments(List<AppointmentEntry> appointments) {
		this.appointments = appointments;
	}

	public String getLastAppointmentDate() {
		if (appointments.size() == 0) {
			return "1900-01-01";
		}
		return getLastAppointment().getDay().substring(0, 10);
	}

	public AppointmentEntry getLastAppointment() {
		if (appointments.size() > 0) {
			return appointments.get(appointments.size() - 1);
		} else {
			return null;
		}
	}

	public String getStartDate() {
		if (appointments.size() > 0) {
			return appointments.get(0).getDay().substring(0, 10);
		} else if (startDate == null) {
			return "1900-01-01";
		} else {
			return startDate;
		}
	}

	private static final SimpleDateFormat DATE_FORMATTER = new SimpleDateFormat("yyyy-MM-dd");

	public String getEndDate() throws ParseException {
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(DATE_FORMATTER.parse(getStartDate()));
		calendar.add(Calendar.MONTH, 3);
		return DATE_FORMATTER.format(calendar.getTime());
	}

	/**
	 * @return the subject
	 * @see #subject
	 */
	public Subject getSubject() {
		return subject;
	}

	/**
	 * @param subject
	 *          the subject to set
	 * @see #subject
	 */
	public void setSubject(Subject subject) {
		this.subject = subject;
	}

	public void setStartDate(String newDate) {
		this.startDate = newDate;
	}

	/**
	 * @return the finished
	 * @see #finished
	 */
	public boolean isFinished() {
		return finished;
	}

	/**
	 * @param finished the finished to set
	 * @see #finished
	 */
	public void setFinished(boolean finished) {
		this.finished = finished;
	}

}
