# coding=utf-8
from django.db import models

__author__ = 'Valentin Grouès'


class Room(models.Model):
    equipment = models.ManyToManyField("web.Item",
                                       verbose_name='On-site equipment',
                                       blank=True
                                       )
    owner = models.CharField(max_length=50,
                             verbose_name='Owner'
                             )
    address = models.CharField(max_length=255,
                               verbose_name='Address'
                               )
    city = models.CharField(max_length=50,
                            verbose_name='City'
                            )
    room_number = models.IntegerField(
        verbose_name='Room number'
    )
    floor = models.IntegerField(
        verbose_name='Floor'
    )
    is_vehicle = models.BooleanField(
        verbose_name='Is a vehicle?'
    )

    def __str__(self):
        return "%d %s %s" % (self.room_number, self.address, self.city)

    def __unicode__(self):
        return "%d %s %s" % (self.room_number, self.address, self.city)
